<template>
  <div class="d-flex flex-column flex-grow-1">
    <div class="d-flex align-center py-3">
      <div>
        <div class="display-1">{{ $t("menu.BeautyCenters") }}</div>
        <v-breadcrumbs :items="breadcrumbs" class="pa-0 py-2"></v-breadcrumbs>
      </div>
      <v-spacer></v-spacer>
    </div>
    <v-card>
      <!-- users list -->
      <v-row dense class="pa-2 align-center">

        <v-col cols="12" class="d-flex text-right align-center">
          <v-text-field
            v-model="searchQuery"
            append-icon="mdi-magnify"
            class="flex-grow-1 mr-md-2"
            solo
            hide-details
            dense
            clearable
            :placeholder="this.$i18n.t('menu.search')"
            @keyup.enter="searchUser()"
          ></v-text-field>
          <v-spacer></v-spacer>

          <v-menu offset-y>
            <template v-slot:activator="{ on, attrs }">
              <v-btn class="mygrad mx-2" rounded dark @click="GoToMaps()">
                {{ $t("menu.SearchByMap") }}
              </v-btn>
              <v-btn class="mygrad mx-2" rounded dark v-bind="attrs" v-on="on">
                {{ $t("provider.SearchBy") }}
              </v-btn>
            </template>
            <v-list>
              <v-list-item
                v-for="(item, index) in items"
                :key="index"
                @click=""
              >
                <v-list-item-title>{{ item.title }}</v-list-item-title>
              </v-list-item>
            </v-list>
          </v-menu>


        </v-col>
      </v-row>

      <v-data-table
        v-model="selectedUsers"
        :headers="headers"
        :items="getProvidersList"
        :search="searchQuery"
        class="flex-grow-1"
        disable-filtering
        disable-pagination
        disable-sort
        hide-default-footer
      >
        <template v-slot:item.email="{ item }">
          <div class="d-flex align-center py-1">
            <v-avatar size="32" class="elevation-1 grey lighten-3">
              <v-img :src="item.avatar" />
            </v-avatar>
            <div class="ml-1 caption font-weight-bold">
              <copy-label :text="item.email" />
            </div>
          </div>
        </template>
        <template v-slot:item.hasIndoor="{ item }">
          <v-icon v-if="item.hasIndoor" small color="success">
            mdi-check-circle
          </v-icon>
          <v-icon v-else small> mdi-circle-outline </v-icon>
        </template>

        <template v-slot:item.isActive="{ item }">
          <v-icon v-if="item.isActive" small color="#AFD5AC">
            mdi-check-circle
          </v-icon>
          <v-icon v-else small color="#E07979"> mdi-circle-outline </v-icon>
        </template>

        <template v-slot:item.isFavorite="{ item }">
          <v-icon v-if="item.isFavorite" small color="red">
            mdi mdi-cards-heart
          </v-icon>
          <v-icon v-else color="#e0e0e0"> mdi mdi-cards-heart </v-icon>
        </template>

        <template v-slot:item.disabled="{ item }">
          <div>{{ item.disabled.toString() | capitalize }}</div>
        </template>

        <template v-slot:item.role="{ item }">
          <v-chip
            label
            small
            class="font-weight-bold"
            :color="item.role === 'ADMIN' ? 'primary' : undefined"
            >{{ item.role | capitalize }}</v-chip
          >
        </template>

        <template v-slot:item.created="{ item }">
          <div>{{ item.created | formatDate("ll") }}</div>
        </template>

        <template v-slot:item.lastSignIn="{ item }">
          <div>{{ item.lastSignIn | formatDate("lll") }}</div>
        </template>

        <template v-slot:item.action="{ item }">

          <v-btn
          :to="'/BeautyExperts/' + item.id"
          color="#AFB2CD"
          dark
          rounded
          >
            {{$t("common.Details")}}
          </v-btn>
        </template>
      </v-data-table>
    </v-card>
    <!-- PAGINATION -->
    <div class="text-center mt-7">
      <v-pagination
        total-visible="7"
        @input="
          $router.replace({ query: { ...$route.query, PageNumber: $event } })
        "
        :value="parseInt(filters.PageNumber)"
        :length="totalPages"
        circle
        color="#AFD5AC"
      ></v-pagination>
    </div>
  </div>
</template>

<script>
import CopyLabel from "../../components/common/CopyLabel";
import { mapActions, mapGetters, mapState, mapMutations } from "vuex";
export default {
  components: {
    CopyLabel,
  },
  data() {
    return {
      Type: 1,
      items: [
        { title: this.$i18n.t("provider.All") },
        { title: this.$i18n.t("provider.SupplierName") },
        { title: this.$i18n.t("provider.ActivityName") },
        { title: this.$i18n.t("provider.ID") },
        { title: this.$i18n.t("provider.ActivityPhoneNumber") },
        { title: this.$i18n.t("provider.SupplierSpecialization") },
        { title: this.$i18n.t("provider.ExecutionPlace") },
      ],
      isLoading: false,
      breadcrumbs: [
        {
          text: this.$i18n.t("menu.BeautyCenters"),
          disabled: false,
          href: "#",
        },
        {
          text: this.$i18n.t("menu.List"),
        },
      ],

      searchQuery: "",
      selectedUsers: [],
      headers: [
        { text: this.$i18n.t("common.name"), value: "name" },
        { text: this.$i18n.t("provider.address"), value: "address" },
        {
          text: this.$i18n.t("provider.availableSlots"),
          value: "availableSlots",
        },
        {
          text: this.$i18n.t("provider.avarageRating"),

          value: "avarageRating",
        },
        { text: this.$i18n.t("provider.discount"), value: "discount" },
        // { text: this.$i18n.t("provider.hasIndoor"), value: "hasIndoor" },
        { text: this.$i18n.t('common.stutas'), value: "isActive" },
        // { text: this.$i18n.t('provider.SalonName'), value: 'SalonName' },
        // { text: this.$i18n.t('provider.SupplierName'), value: 'SupplierName' },
        { text: this.$i18n.t('common.Details'),   value: "action" },
      ],
    };
  },
  methods: {
    GoToMaps() {
      window.location.href = "https:/www.google.com/maps";
    },
    ...mapMutations("users", ["setfilters"]),
    ...mapActions("users", ["fetchBeautyCenters"]),
    searchUser() {

      this.fetchBeautyCenters({SearchText: this.searchQuery});
    },
    open() {},
  },
  watch: {
    selectedUsers(val) {},
    $route: {
      async handler(route) {
        if (!route.query.PageNumber) {
          await this.$router.replace({
            query: { ...route.query, PageNumber: 1 },
          });
          return;
        }

        this.setfilters({ ...route.query });
        this.fetchBeautyCenters(route.query);
      },
      deep: true,
      immediate: true,
    },
  },

  mounted() {
    this.fetchBeautyCenters();
  },
  computed: {
    ...mapGetters("users", ["getProvidersList"]),
    ...mapState("users", ["filters", "totalPages"]),
  },
};
</script>

<style lang="scss" scoped>
.slide-fade-enter-active {
  transition: all 0.3s ease;
}
.slide-fade-leave-active {
  transition: all 0.3s cubic-bezier(1, 0.5, 0.8, 1);
}
.slide-fade-enter,
.slide-fade-leave-to {
  transform: translateX(10px);
  opacity: 0;
}
</style>
